Add support for Google OAuth2 authentication
[rails.git] / config / initializers / omniauth.rb
index 8190a65b96fb63b4c30773a0f5b5b8aa85e86ce1..6de63f6ee73430f8ff997261a9c8b26883d63cf4 100644 (file)
@@ -1,8 +1,10 @@
 require "openid/fetchers"
+require "openid/util"
 
 CA_BUNDLES = ["/etc/ssl/certs/ca-certificates.crt", "/etc/pki/tls/cert.pem"]
 
 OpenID.fetcher.ca_file = CA_BUNDLES.find { |f| File.exist?(f) }
+OpenID::Util.logger = Rails.logger
 
 OmniAuth.config.logger = Rails.logger
 OmniAuth.config.failure_raise_out_environments = []
@@ -17,8 +19,16 @@ else
   openid_store = OpenID::Store::Filesystem.new(Rails.root.join("tmp/openids"))
 end
 
+openid_options = { :name => "openid", :store => openid_store }
+google_options = { :name => "google", :scope => "email", :access_type => "online" }
+
+if defined?(GOOGLE_OPENID_REALM)
+  google_options[:openid_realm] = GOOGLE_OPENID_REALM
+end
+
 Rails.application.config.middleware.use OmniAuth::Builder do
-  provider :openid, :name => "openid", :store => openid_store
+  provider :openid, openid_options
+  provider :google_oauth2, GOOGLE_AUTH_ID, GOOGLE_AUTH_SECRET, google_options if defined?(GOOGLE_AUTH_ID)
 end
 
 # Pending fix for: https://github.com/intridea/omniauth/pull/795